/*
 * ttLuaCOM.h
 */

#include <ole2.h>
#include <ocidl.h> 

#include "LuaPlus/LuaPlus.h"
using namespace LuaPlus;

#include "luabeans.h"
#include "tLuaCOMTypeHandler.h"

#include "tLuaObjList.h"

enum tWhichInterface {DISP, SOURCE};

class tLuaCOM
{
public:
	void GetIID(IID *piid);
	IDispatch * GetIDispatch(void);
	void ReleaseFuncDesc(FUNCDESC *pfuncdesc);
	ITypeInfo * GetDefaultEventsInterface(void);
	static tLuaCOM * CreateLuaCOM(LuaState* state, IDispatch *pdisp);
	static tLuaCOM *CreateLuaCOM(LuaState* state, IUnknown *punk);
	static tLuaCOM* CreateLuaCOM(LuaState* state, ITypeInfo* ptinfo);
	void getHelpInfo(char **ppHelpFile, unsigned long *pHelpContext);
	bool isMember(const char *name);

	bool HasEnum()			{  return pdisp == NULL  &&  ptinfo != NULL;  }
	tLuaCOM* GetEnum(const char* name);
	bool LookupEnum(const char* name);

	tLuaCOM* NewInterface(const char* pcInterface);


  static LuaBeans* lbeans;


   ~tLuaCOM();

   bool addConnection(tLuaCOM *client);
   void releaseConnection(void);

   int call(FUNCDESC *pfuncdesc, tLuaObjList& params);
   int putprop(FUNCDESC* pfuncdesc,LuaStackObject val);
   int getprop(FUNCDESC* pfuncdesc);
   HRESULT get_funcdescr(DISPID dispid,INVOKEKIND invkind,
                         FUNCDESC** ppfuncdesc);
   HRESULT get_dispid(const char* name, DISPID* dispid);

  static bool GetDefaultEventsInterface(IUnknown *punk,
                                         IID *piid, 
                                         ITypeInfo **pptypeinfo);

  static bool GetDefaultDispinterface(IUnknown *punk,
                                      IID *piid,
                                      ITypeInfo **pptypeinfo);

  static char* TAG;
protected:
  tLuaCOM(LuaState* state, IDispatch *pdisp_arg, ITypeInfo *ptinfo_arg);

	static bool GetTypeInfoFromIUnknown(IUnknown *punk,
                                      ITypeInfo **pptypeinfo,
                                      tWhichInterface iface);

	static bool GetCoClassTypeInfo(IUnknown *punk, ITypeInfo **ppTypeinfo);
  

	tLuaCOMTypeHandler * typehandler;


  LPDISPATCH pdisp;
  ITypeInfo* ptinfo;
  IConnectionPoint *connection_point;
  DWORD connection_point_cookie;
  LuaState* m_state;
};
