#include "../../LuaPlus/LuaPlus.h"
#include "FileGlobBase.h"

using namespace LuaPlus;

class LuaFileGlob : public FileGlobBase
{
public:
	LuaFileGlob() :
		m_numEntries( 0 )
	{
	}

	virtual void FoundMatch( const char* name )
	{
		m_numEntries++;
		m_tableObj.SetString( m_numEntries, name );
	}

	LuaStackObject m_tableObj;
	int m_numEntries;
};


static int LS_Glob_MatchPattern( LuaState* state )
{
	LuaStack args(state);
	LuaFileGlob fileGlob;

	fileGlob.m_tableObj = state->NewTable();
	fileGlob.MatchPattern( args[ 1 ].GetString() );

	fileGlob.m_tableObj.Push();

	return 1;
}


extern "C" __declspec(dllexport) void LuaPlus_RegisterModule( LuaState* state )
{
	LuaObject globObj = state->GetGlobals().CreateTable( "glob" );
	globObj.Register( "match", LS_Glob_MatchPattern );
}


extern "C" __declspec(dllexport) void LuaPlus_UnregisterModule( LuaState* state )
{
	state->GetGlobals().SetNil( "glob" );
}

