#include <windows.h>
#include "LuaPlus/LuaPlus.h"

using namespace LuaPlus;

static int LS_GetText( LuaState* state )
{
	if (OpenClipboard(NULL))
	{
		HANDLE hData = ::GetClipboardData(CF_TEXT);
		if (hData)
		{
			char* data = (char*)::GlobalLock(hData);
			state->PushString(data);

			::GlobalUnlock(hData);
		}
		else
		{
			state->PushString("");
		}

		CloseClipboard();
	}
	else
	{
		state->PushString("");
	}

	return 1;
}


extern "C" __declspec(dllexport) void LuaPlus_RegisterModule( LuaState* state )
{
	LuaObject pipeObj = state->GetGlobals().CreateTable( "clipboard" );
	pipeObj.Register( "GetText", LS_GetText );
}


extern "C" __declspec(dllexport) void LuaPlus_UnregisterModule( LuaState* state )
{
	state->GetGlobals().SetNil( "clipboard" );
}

